if not Watcher then return end

if select(2, UnitClass('player')) ~= "HUNTER" then return end

local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = Watcher.constants

function Watcher:GetSerpentStingInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitDebuff("target", index)
		if name == C["Serpent Sting"] and caster == "player" then 
			return true, debuffExpires - GetTime()
		end
		index = index + 1
	end
	return false, 0
end

function Watcher:GetHMInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires = UnitDebuff("target", index)
		if name == C["Hunter's Mark"] then 
			return true, debuffExpires - GetTime()
		end
		index = index + 1
	end
	return false, 0
end

function Watcher:GetESTickInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, debuffExpires, caster = UnitDebuff("target", index)
			if name == C["Explosive Shot"] and caster == "player" then 
				return true, debuffExpires - GetTime()
			end
			
		index = index + 1
	end
	return false, 0
end

function Watcher:GetLockandLoadInfo()
	local index = 1
	while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, lnlTime = UnitBuff("PLAYER", index)
		if name == C["Lock and Load"] then
			return count, lnlTime
		end
		index = index + 1
	end
	return 0, 0 
end

Watcher.priorityTable.name["hm"] = C["Hunter's Mark"]
Watcher.priorityTable.icon["hm"] = C["Hunter's Mark Icon"]
Watcher.priorityTable.check["hm"] =  
	function (FrameName, optionnum) 
		local started, expiresin = Watcher:GetHMInfo()
		local start, duration = GetSpellCooldown(C["Hunter's Mark"])
		local timeleft = start + duration - GetTime()
		if expiresin > 0 or duration > 0 then
			if expiresin > Watcher.db.char.priority.maxtime then
				FrameName:SetAlpha(0)
			else
				FrameName:SetAlpha(1)
			end
			if timeleft > expiresin then
				Watcher:MoveIcon(FrameName, timeleft)
				FrameName.Text:SetText(Watcher:DurationString(timeleft))
				FrameName.Text:Show()
				ready[optionnum] = false
				return
			else
				timeleft = expiresin
				Watcher:MoveIcon(FrameName, timeleft)
				FrameName.Text:SetText(Watcher:DurationString(timeleft))
				FrameName.Text:Show()
				ready[optionnum] = false
				return
			end	
		end
			FrameName.Text:Hide()
			ready[optionnum] = true
			Watcher:GetReady(optionnum)
			Watcher:SetReadyPoint(FrameName, offset)
		end
		
Watcher.priorityTable.name["gcd"] = C["Beast Lore"]
Watcher.priorityTable.icon["gcd"] = C["Beast Lore Icon"]
Watcher.priorityTable.check["gcd"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Beast Lore"])
		if duration > 0 then
			FrameName:SetAlpha(1)
			local timeleft = start + duration - GetTime()
			Watcher:MoveIcon(FrameName, timeleft)
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			return
		end
		if start == 0 then
			FrameName.Text:Hide()
			FrameName:SetAlpha(0)
		else
			FrameName.Text:Show()
		end
	end 
	
Watcher.priorityTable.name["rf"] = C["Rapid Fire"]
Watcher.priorityTable.icon["rf"] = C["Rapid Fire Icon"]
Watcher.priorityTable.check["rf"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Rapid Fire"])
		if duration > 0 then
			local timeleft = start + duration - GetTime()
			if timeleft > Watcher.db.char.priority.maxtime then
				FrameName:SetAlpha(0)
			else
				FrameName:SetAlpha(1)
			end

			Watcher:MoveIcon(FrameName, timeleft)
			if Watcher.db.char.priority.textshow then
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			FrameName.Text:Show()
			end
			ready[optionnum] = false
			return
		end
		FrameName.Text:Hide()
		ready[optionnum] = true
		Watcher:GetReady(optionnum)
		Watcher:SetReadyPoint(FrameName, offset)	
		end 
	
Watcher.priorityTable.name["bf"] = C["Blood Fury"]
Watcher.priorityTable.icon["bf"] = C["Blood Fury Icon"]
Watcher.priorityTable.check["bf"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Blood Fury"])
		if duration > 0 then
			local timeleft = start + duration - GetTime()
			if timeleft > Watcher.db.char.priority.maxtime then
				FrameName:SetAlpha(0)
			else
				FrameName:SetAlpha(1)
			end	
			Watcher:MoveIcon(FrameName, timeleft)
			if Watcher.db.char.priority.textshow then
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			FrameName.Text:Show()
			end
			ready[optionnum] = false
			return
		end
		FrameName.Text:Hide()
		ready[optionnum] = true
		Watcher:GetReady(optionnum)
		Watcher:SetReadyPoint(FrameName, offset)	
		end
	
Watcher.priorityTable.name["bw"] = C["Bestial Wrath"]
Watcher.priorityTable.icon["bw"] = C["Bestial Wrath Icon"]
Watcher.priorityTable.check["bw"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Bestial Wrath"])
		if duration > 0 then
			local timeleft = start + duration - GetTime()
			if timeleft > Watcher.db.char.priority.maxtime then
				FrameName:SetAlpha(0)
			else
				FrameName:SetAlpha(1)
			end
			Watcher:MoveIcon(FrameName, timeleft)
			if Watcher.db.char.priority.textshow then
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			FrameName.Text:Show()
			end
			ready[optionnum] = false
			return
		end
		FrameName.Text:Hide()
		ready[optionnum] = true
		Watcher:GetReady(optionnum)
		Watcher:SetReadyPoint(FrameName, offset)	
		end

Watcher.priorityTable.name["ss"] = C["Serpent Sting"]
Watcher.priorityTable.icon["ss"] = C["Serpent Sting Icon"]
Watcher.priorityTable.check["ss"] =  
	function (FrameName, optionnum) 
		local started, expiresin = Watcher:GetSerpentStingInfo()
		local start, duration = GetSpellCooldown(C["Serpent Sting"])
		local timeleft = start + duration - GetTime()
		if expiresin > 0 or duration > 0 then
		if expiresin > Watcher.db.char.priority.maxtime then
		FrameName:SetAlpha(0)
		else
		FrameName:SetAlpha(1)
		end
		if timeleft > expiresin then
			Watcher:MoveIcon(FrameName, timeleft)
			if Watcher.db.char.priority.textshow then
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			FrameName.Text:Show()
			end
			ready[optionnum] = false
			return
		else
			timeleft = expiresin
			Watcher:MoveIcon(FrameName, timeleft)
			if Watcher.db.char.priority.textshow then
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			FrameName.Text:Show()
			end
			ready[optionnum] = false
			return
		end	
		end
			FrameName.Text:Hide()
			ready[optionnum] = true
			Watcher:GetReady(optionnum)
			Watcher:SetReadyPoint(FrameName, offset)
			
		end
	
Watcher.priorityTable.name["aimedshot"] = C["Aimed Shot"]
Watcher.priorityTable.icon["aimedshot"] = C["Aimed Shot Icon"]
Watcher.priorityTable.check["aimedshot"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Aimed Shot"])
		if duration > 0 then
			local timeleft = start + duration - GetTime()
			if timeleft > Watcher.db.char.priority.maxtime then
				FrameName:SetAlpha(0)
			else
				FrameName:SetAlpha(1)
			end
			Watcher:MoveIcon(FrameName, timeleft)
			if Watcher.db.char.priority.textshow then
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			FrameName.Text:Show()
			end
			ready[optionnum] = false
			return
		end
		FrameName.Text:Hide()
		ready[optionnum] = true
		Watcher:GetReady(optionnum)
		Watcher:SetReadyPoint(FrameName, offset)	
		end
	
Watcher.priorityTable.name["cs"] = C["Chimera Shot"]
Watcher.priorityTable.icon["cs"] = C["Chimera Shot Icon"]
Watcher.priorityTable.check["cs"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Chimera Shot"])
		if duration > 0 then
			local timeleft = start + duration - GetTime()
			if timeleft > Watcher.db.char.priority.maxtime then
				FrameName:SetAlpha(0)
			else
				FrameName:SetAlpha(1)
			end
			Watcher:MoveIcon(FrameName, timeleft)
			if Watcher.db.char.priority.textshow then
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			FrameName.Text:Show()
			end
			ready[optionnum] = false
			return
		end
		FrameName.Text:Hide()
		ready[optionnum] = true
		Watcher:GetReady(optionnum)
		Watcher:SetReadyPoint(FrameName, offset)	
		end
	
Watcher.priorityTable.name["arcaneshot"] = C["Arcane Shot"]
Watcher.priorityTable.icon["arcaneshot"] = C["Arcane Shot Icon"]
Watcher.priorityTable.check["arcaneshot"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Arcane Shot"])
		if duration > 0 then
			local timeleft = start + duration - GetTime()
			if timeleft > Watcher.db.char.priority.maxtime then
				FrameName:SetAlpha(0)
			else
				FrameName:SetAlpha(1)
			end
			Watcher:MoveIcon(FrameName, timeleft)
			if Watcher.db.char.priority.textshow then
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			FrameName.Text:Show()
			end
			ready[optionnum] = false
			return
		end
		FrameName.Text:Hide()
		ready[optionnum] = true
		Watcher:GetReady(optionnum)
		Watcher:SetReadyPoint(FrameName, offset)	
		end
	
Watcher.priorityTable.name["multishot"] = C["Multi-Shot"]
Watcher.priorityTable.icon["multishot"] = C["Multi-Shot Icon"]
Watcher.priorityTable.check["multishot"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Multi-Shot"])
		if duration > 0 then
			local timeleft = start + duration - GetTime()
			if timeleft > Watcher.db.char.priority.maxtime then
				FrameName:SetAlpha(0)
			else
				FrameName:SetAlpha(1)
			end
			Watcher:MoveIcon(FrameName, timeleft)
			if Watcher.db.char.priority.textshow then
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			FrameName.Text:Show()
			end
			ready[optionnum] = false
			return
		end
		FrameName.Text:Hide()
		ready[optionnum] = true
		Watcher:GetReady(optionnum)
		Watcher:SetReadyPoint(FrameName, offset)	
		end
	
Watcher.priorityTable.name["steadyshot"] = C["Steady Shot"]
Watcher.priorityTable.icon["steadyshot"] = C["Steady Shot Icon"]
Watcher.priorityTable.check["steadyshot"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Steady Shot"])
		if duration > 0 then
			local timeleft = start + duration - GetTime()
			if timeleft > Watcher.db.char.priority.maxtime then
				FrameName:SetAlpha(0)
			else
				FrameName:SetAlpha(1)
			end
			Watcher:MoveIcon(FrameName, timeleft)
			if Watcher.db.char.priority.textshow then
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			FrameName.Text:Show()
			end
			ready[optionnum] = false
			return
		end
		FrameName.Text:Hide()
		ready[optionnum] = true
		Watcher:GetReady(optionnum)
		Watcher:SetReadyPoint(FrameName, offset)	
		end
	
	
Watcher.priorityTable.name["killshot"] = C["Kill Shot"]
Watcher.priorityTable.icon["killshot"] = C["Kill Shot Icon"]
Watcher.priorityTable.check["killshot"] =  
	function (FrameName, optionnum) 
		local health = UnitHealth("target")
		local maxhealth = UnitHealthMax("target")
		local healthpercent = health / maxhealth
		if healthpercent <= 0.2 then
			FrameName:SetAlpha(1)
			local start, duration = GetSpellCooldown(C["Kill Shot"])
			if duration > 0 then
				local timeleft = start + duration - GetTime()
				if timeleft > Watcher.db.char.priority.maxtime then
					FrameName:SetAlpha(0)
				else
					FrameName:SetAlpha(1)
				end
				Watcher:MoveIcon(FrameName, timeleft)
				if Watcher.db.char.priority.textshow then
				FrameName.Text:SetText(Watcher:DurationString(timeleft))
				FrameName.Text:Show()
				end
				ready[optionnum] = false
				return
			end
		
		FrameName.Text:Hide()
		ready[optionnum] = true
		Watcher:GetReady(optionnum)
		Watcher:SetReadyPoint(FrameName, offset)
		else
		ready[optionnum] = false
		FrameName:SetAlpha(0)
		return
		end
	end
	
Watcher.priorityTable.name["es"] = C["Explosive Shot"]
Watcher.priorityTable.icon["es"] = C["Explosive Shot Icon"]
Watcher.priorityTable.check["es"] =  
	function (FrameName, optionnum) 
				local start, duration = GetSpellCooldown(C["Explosive Shot"])
				if not start then
				start = 0
				end
				local dotexists, dotduration = Watcher:GetESTickInfo()
				local timeleft = start + duration - GetTime()
				if duration > 0 or dotduration > 0 then			
					if timeleft > Watcher.db.char.priority.maxtime then
						FrameName:SetAlpha(0)
					else
						FrameName:SetAlpha(1)
					end					
					Watcher:MoveIcon(FrameName, timeleft)
					if dotduration >= timeleft then
						timeleft = dotduration
						Watcher:MoveIcon(FrameName, timeleft)
					end
					if Watcher.db.char.priority.textshow then
					FrameName.Text:SetText(Watcher:DurationString(timeleft))
					FrameName.Text:Show()
					end
					ready[optionnum] = false
					return
				end
				FrameName.Text:Hide()
				ready[optionnum] = true
				Watcher:GetReady(optionnum)
				Watcher:SetReadyPoint(FrameName, offset)
	end 	


	
Watcher.priorityTable.name["ba"] = C["Black Arrow"]
Watcher.priorityTable.icon["ba"] = C["Black Arrow Icon"]
Watcher.priorityTable.check["ba"] =  
	function (FrameName, optionnum) 	
		local start, duration = GetSpellCooldown(C["Black Arrow"])
		if duration > 0 then
			local timeleft = start + duration - GetTime()
			if timeleft > Watcher.db.char.priority.maxtime then
				FrameName:SetAlpha(0)
			else
				FrameName:SetAlpha(1)
			end
			Watcher:MoveIcon(FrameName, timeleft)
			if Watcher.db.char.priority.textshow then
			FrameName.Text:SetText(Watcher:DurationString(timeleft))
			FrameName.Text:Show()
			end
			ready[optionnum] = false
			return
		end
		FrameName.Text:Hide()
		ready[optionnum] = true
		Watcher:GetReady(optionnum)
		Watcher:SetReadyPoint(FrameName, offset)	
		end	